x = 0:.05:1; y = 0:.05:1;
[X,Y] = meshgrid(x,y);
f = 0*X+1;

%Get the 2-d samples for the "floor"
Samples = rand(1000,2);

figure
subplot(1,2,1)
surf(x,y,f);
hold on;
%Plot the samples on the "floor"
plot3(Samples(:,1),Samples(:,2),zeros(size(Samples,1),1),'r.','MarkerSize',4)
%caxis([min(F(:))-.5*range(F(:)),max(F(:))]);
axis([0.0 1.0 0.0 1.0 0 1.1])
xlabel('x'); ylabel('y'); zlabel('f_{X,Y}(x,y)');
%fill([1/4 1/4 1/2 1/2 1/4]',[1/3 2/3 2/3 1/3 1/3]','y');
axis equal
grid on; view(45,27);
hold off

subplot(1,2,2)
%Plot the samples on the "floor"
plot3(Samples(:,1),Samples(:,2),zeros(size(Samples,1),1),'r.','MarkerSize',4)
axis([0.0 1.0 0.0 1.0 0 1.2])
xlabel('x'); ylabel('y'); zlabel('f_{X,Y}(x,y)');
axis equal
hold on;
%Plot the histograms on the walls from the data in the middle
[n_x, xout] = hist(Samples(:,1),10);%Creates 10 bars
n_x = n_x ./ ( sum(n_x) *(xout(2)-xout(1)));%Normalizes to be a pdf
[~,~,~,x_Pos,x_Height] = makebars(xout,n_x);%Creates the bar points
plot3(x_Pos, Y(end)*ones(size(x_Pos)),x_Height,'-k')
 
%Now plot the other histograms on the wall
[n_y, yout] = hist(Samples(:,2),10);
n_y = n_y ./ ( sum(n_y) *(yout(2)-yout(1)));
[~,~,~,y_Pos,y_Height] = makebars(yout,n_y);
plot3(X(1)*ones(size(y_Pos)),y_Pos, y_Height,'-k')

%Now plot the 1-d pdfs over the histograms
plot3(x, ones(size(x))*x(end), ones(size(x)),'-b','LineWidth',2); 
plot3(ones(size(y))*x(1), y, ones(size(y)),'-r','LineWidth',2);

plot3(0.5,y(end),0,'b.','MarkerSize',15)
plot3(x(1),0.5,0,'r.','MarkerSize',15)
plot3(0.5,0.5,0,'m.','MarkerSize',30)
%Make the figure look nice
grid on; view(45,27);
axis([0.0 1.0 0.0 1.0 0 1.2])
%axis([X(1) X(end) Y(1) Y(end)])

hold off