% script to plot the oscillating running mean of Std Cauchy samples
% relative to those for the Uniform(0,10) samples
rand('twister',25567);        % initialize the fundamental sampler
%subplot(1,2,1)
for i=1:20
N = 10^1;                         % maximum sample size
u=rand(1,N);            % draw N IID samples from Uniform(0,1)
x=ceil(u-0.5);%tan(pi * u);     % draw N IID samples from Standard cauchy RV using inverse CDF
n=1:N;              % make a vector n of current sample size [1 2 3 ... N-1 N]
CSx=cumsum(x); % CSx is the cumulative sum of the array x (type 'help cumsum')
% Runnign Means <- vector division of cumulative sum of samples by n
RunningMeanFairCoin = CSx ./ n; % Running Mean for Standard Cauchy samples 
RunningMeanFairDie = cumsum(ceil(u*6)) ./ n; % Running Mean for Uniform(0,10) samples
semilogx(n, RunningMeanFairDie, 'b') % 
hold on;
semilogx(n, RunningMeanFairCoin, 'm')
end
xlabel('n = sample size');
ylabel('sample mean (from n samples)')

% subplot(1,2,2)
% for i=1:20
% N = 10^5;                         % maximum sample size
% u=rand(1,N);            % draw N IID samples from Uniform(0,1)
% x=u*30;%tan(pi * u);     % draw N IID samples from Standard cauchy RV using inverse CDF
% n=1:N;              % make a vector n of current sample size [1 2 3 ... N-1 N]
% CSx=cumsum(x); % CSx is the cumulative sum of the array x (type 'help cumsum')
% % Runnign Means <- vector division of cumulative sum of samples by n
% RunningMeanUniform01 = CSx ./ n; % Running Mean for Standard Cauchy samples 
% RunningMeanExp1By10 = cumsum(-10 * log(u)) ./ n; % Running Mean for Uniform(0,10) samples
% semilogx(n, RunningMeanExp1By10, 'r') % 
% hold on;
% semilogx(n, RunningMeanUniform01, 'g')
% end
% xlabel('n = sample size');
% ylabel('sample mean (from n samples)')
