%% How to download data from an URL directly without having to manually
%% fill out forms
% first make a string of the data using urlread (read help urlread if you want details)
StringData = urlread('http://www.math.canterbury.ac.nz/php/lib/cliflo/rainfall.php');
RainFallsChch = textscan(StringData, '%d %f', 'delimiter', ',')
RC = [RainFallsChch{1} RainFallsChch{2}]; % assign Matlab cells as a matrix
size(RC) % find the size of the matrix

FirstDayOfData = min(RC(:,1))
LastDayOfData = max(RC(:,1))

clf
subplot(1,3,1)
plot(RC(:,2),'.')
xlim([1, length(RC(:,2))])
xlabel('Days since 02/08/1943','FontSize',10);
ylabel('Rainfall in millimeters','FontSize',10)

subplot(1,3,2)
[f,x] = ecdf(RC(:,2));
stairs(x,f);
ylim([0.7,1.01])
ylabel('Empirical CDF','FontSize',10);
xlabel('Rainfall in millimeters','FontSize',10)


subplot(1,3,3)
ecdfhist(f,x,50)
ylabel('Empirical Frequency','FontSize',10);
xlabel('Rainfall in millimeters','FontSize',10)

%figure
%RainyDays=RC(:,2)>0
%Rains=RC(RainyDays,2)
%hist(Rains/1.0)
%datestr(datenum(num2str(RC(RainyDays)),'yyyymmdd'))